<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>KerberosName.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.auth</a> &gt; <span class="el_source">KerberosName.java</span></div><h1>KerberosName.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

 /* This file copied from Hadoop's security branch,
  * with the following changes:
  * 1. package changed from org.apache.hadoop.security to
  *    org.apache.zookeeper.server.auth.
  * 2. Usage of Hadoop's Configuration class removed since
  *    it is not available in Zookeeper: instead, system property
  *    &quot;zookeeper.security.auth_to_local&quot; is used.
  */

package org.apache.zookeeper.server.auth;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.zookeeper.server.util.KerberosUtil;

/**
 * This class implements parsing and handling of Kerberos principal names. In 
 * particular, it splits them apart and translates them down into local
 * operating system names.
 */
public class KerberosName {
  /** The first component of the name */
  private final String serviceName;
  /** The second component of the name. It may be null. */
  private final String hostName;
  /** The realm of the name. */
  private final String realm;

  /**
   * A pattern that matches a Kerberos name with at most 2 components.
   */
<span class="fc" id="L54">  private static final Pattern nameParser = </span>
<span class="fc" id="L55">    Pattern.compile(&quot;([^/@]*)(/([^/@]*))?@([^/@]*)&quot;);</span>

  /** 
   * A pattern that matches a string with out '$' and then a single
   * parameter with $n.
   */
<span class="fc" id="L61">  private static Pattern parameterPattern = </span>
<span class="fc" id="L62">    Pattern.compile(&quot;([^$]*)(\\$(\\d*))?&quot;);</span>

  /**
   * A pattern for parsing a auth_to_local rule.
   */
<span class="fc" id="L67">  private static final Pattern ruleParser =</span>
<span class="fc" id="L68">    Pattern.compile(&quot;\\s*((DEFAULT)|(RULE:\\[(\\d*):([^\\]]*)](\\(([^)]*)\\))?&quot;+</span>
                    &quot;(s/([^/]*)/([^/]*)/(g)?)?))&quot;);
  
  /**
   * A pattern that recognizes simple/non-simple names.
   */
<span class="fc" id="L74">  private static final Pattern nonSimplePattern = Pattern.compile(&quot;[/@]&quot;);</span>
  
  /**
   * The list of translation rules.
   */
  private static List&lt;Rule&gt; rules;

  private static String defaultRealm;
  
  static {
    try {
<span class="nc" id="L85">      defaultRealm = KerberosUtil.getDefaultRealm();</span>
<span class="fc" id="L86">    } catch (Exception ke) {</span>
<span class="pc bpc" id="L87" title="1 of 2 branches missed.">      if ((System.getProperty(&quot;zookeeper.requireKerberosConfig&quot;) != null) &amp;&amp;</span>
<span class="nc bnc" id="L88" title="All 2 branches missed.">          (System.getProperty(&quot;zookeeper.requireKerberosConfig&quot;).equals(&quot;true&quot;))) {</span>
<span class="nc" id="L89">        throw new IllegalArgumentException(&quot;Can't get Kerberos configuration&quot;,ke);</span>
      }
      else
<span class="fc" id="L92">        defaultRealm=&quot;&quot;;</span>
<span class="nc" id="L93">    }</span>
    try {
      // setConfiguration() will work even if the above try() fails due
      // to a missing Kerberos configuration (unless zookeeper.requireKerberosConfig
      // is set to true, which would not allow execution to reach here due to the
      // throwing of an IllegalArgumentException above).
<span class="fc" id="L99">      setConfiguration();</span>
    }
<span class="nc" id="L101">    catch (IOException e) {</span>
<span class="nc" id="L102">      throw new IllegalArgumentException(&quot;Could not configure Kerberos principal name mapping.&quot;);</span>
<span class="fc" id="L103">    }</span>
<span class="fc" id="L104">  }</span>

  /**
   * Create a name from the full Kerberos principal name.
   * @param name
   */
<span class="fc" id="L110">  public KerberosName(String name) {</span>
<span class="fc" id="L111">    Matcher match = nameParser.matcher(name);</span>
<span class="fc bfc" id="L112" title="All 2 branches covered.">    if (!match.matches()) {</span>
<span class="fc bfc" id="L113" title="All 2 branches covered.">      if (name.contains(&quot;@&quot;)) {</span>
<span class="fc" id="L114">        throw new IllegalArgumentException(&quot;Malformed Kerberos name: &quot; + name);</span>
      } else {
<span class="fc" id="L116">        serviceName = name;</span>
<span class="fc" id="L117">        hostName = null;</span>
<span class="fc" id="L118">        realm = null;</span>
      }
    } else {
<span class="fc" id="L121">      serviceName = match.group(1);</span>
<span class="fc" id="L122">      hostName = match.group(3);</span>
<span class="fc" id="L123">      realm = match.group(4);</span>
    }
<span class="fc" id="L125">  }</span>

  /**
   * Get the configured default realm.
   * @return the default realm from the krb5.conf
   */
  public String getDefaultRealm() {
<span class="nc" id="L132">    return defaultRealm;</span>
  }

  /**
   * Put the name back together from the parts.
   */
  @Override
  public String toString() {
<span class="nc" id="L140">    StringBuilder result = new StringBuilder();</span>
<span class="nc" id="L141">    result.append(serviceName);</span>
<span class="nc bnc" id="L142" title="All 2 branches missed.">    if (hostName != null) {</span>
<span class="nc" id="L143">      result.append('/');</span>
<span class="nc" id="L144">      result.append(hostName);</span>
    }
<span class="nc bnc" id="L146" title="All 2 branches missed.">    if (realm != null) {</span>
<span class="nc" id="L147">      result.append('@');</span>
<span class="nc" id="L148">      result.append(realm);</span>
    }
<span class="nc" id="L150">    return result.toString();</span>
  }

  /**
   * Get the first component of the name.
   * @return the first section of the Kerberos principal name
   */
  public String getServiceName() {
<span class="nc" id="L158">    return serviceName;</span>
  }

  /**
   * Get the second component of the name.
   * @return the second section of the Kerberos principal name, and may be null
   */
  public String getHostName() {
<span class="fc" id="L166">    return hostName;</span>
  }
  
  /**
   * Get the realm of the name.
   * @return the realm of the name, may be null
   */
  public String getRealm() {
<span class="fc" id="L174">    return realm;</span>
  }
  
  /**
   * An encoding of a rule for translating kerberos names.
   */
  private static class Rule {
    private final boolean isDefault;
    private final int numOfComponents;
    private final String format;
    private final Pattern match;
    private final Pattern fromPattern;
    private final String toPattern;
    private final boolean repeat;

<span class="fc" id="L189">    Rule() {</span>
<span class="fc" id="L190">      isDefault = true;</span>
<span class="fc" id="L191">      numOfComponents = 0;</span>
<span class="fc" id="L192">      format = null;</span>
<span class="fc" id="L193">      match = null;</span>
<span class="fc" id="L194">      fromPattern = null;</span>
<span class="fc" id="L195">      toPattern = null;</span>
<span class="fc" id="L196">      repeat = false;</span>
<span class="fc" id="L197">    }</span>

    Rule(int numOfComponents, String format, String match, String fromPattern,
<span class="nc" id="L200">         String toPattern, boolean repeat) {</span>
<span class="nc" id="L201">      isDefault = false;</span>
<span class="nc" id="L202">      this.numOfComponents = numOfComponents;</span>
<span class="nc" id="L203">      this.format = format;</span>
<span class="nc bnc" id="L204" title="All 2 branches missed.">      this.match = match == null ? null : Pattern.compile(match);</span>
<span class="nc bnc" id="L205" title="All 2 branches missed.">      this.fromPattern = </span>
<span class="nc" id="L206">        fromPattern == null ? null : Pattern.compile(fromPattern);</span>
<span class="nc" id="L207">      this.toPattern = toPattern;</span>
<span class="nc" id="L208">      this.repeat = repeat;</span>
<span class="nc" id="L209">    }</span>
    
    @Override
    public String toString() {
<span class="nc" id="L213">      StringBuilder buf = new StringBuilder();</span>
<span class="nc bnc" id="L214" title="All 2 branches missed.">      if (isDefault) {</span>
<span class="nc" id="L215">        buf.append(&quot;DEFAULT&quot;);</span>
      } else {
<span class="nc" id="L217">        buf.append(&quot;RULE:[&quot;);</span>
<span class="nc" id="L218">        buf.append(numOfComponents);</span>
<span class="nc" id="L219">        buf.append(':');</span>
<span class="nc" id="L220">        buf.append(format);</span>
<span class="nc" id="L221">        buf.append(']');</span>
<span class="nc bnc" id="L222" title="All 2 branches missed.">        if (match != null) {</span>
<span class="nc" id="L223">          buf.append('(');</span>
<span class="nc" id="L224">          buf.append(match);</span>
<span class="nc" id="L225">          buf.append(')');</span>
        }
<span class="nc bnc" id="L227" title="All 2 branches missed.">        if (fromPattern != null) {</span>
<span class="nc" id="L228">          buf.append(&quot;s/&quot;);</span>
<span class="nc" id="L229">          buf.append(fromPattern);</span>
<span class="nc" id="L230">          buf.append('/');</span>
<span class="nc" id="L231">          buf.append(toPattern);</span>
<span class="nc" id="L232">          buf.append('/');</span>
<span class="nc bnc" id="L233" title="All 2 branches missed.">          if (repeat) {</span>
<span class="nc" id="L234">            buf.append('g');</span>
          }
        }
      }
<span class="nc" id="L238">      return buf.toString();</span>
    }
    
    /**
     * Replace the numbered parameters of the form $n where n is from 1 to 
     * the length of params. Normal text is copied directly and $n is replaced
     * by the corresponding parameter.
     * @param format the string to replace parameters again
     * @param params the list of parameters
     * @return the generated string with the parameter references replaced.
     * @throws BadFormatString
     */
    static String replaceParameters(String format, 
                                    String[] params) throws BadFormatString {
<span class="nc" id="L252">      Matcher match = parameterPattern.matcher(format);</span>
<span class="nc" id="L253">      int start = 0;</span>
<span class="nc" id="L254">      StringBuilder result = new StringBuilder();</span>
<span class="nc bnc" id="L255" title="All 4 branches missed.">      while (start &lt; format.length() &amp;&amp; match.find(start)) {</span>
<span class="nc" id="L256">        result.append(match.group(1));</span>
<span class="nc" id="L257">        String paramNum = match.group(3);</span>
<span class="nc bnc" id="L258" title="All 2 branches missed.">        if (paramNum != null) {</span>
          try {
<span class="nc" id="L260">            int num = Integer.parseInt(paramNum);</span>
<span class="nc bnc" id="L261" title="All 4 branches missed.">            if (num &lt; 0 || num &gt; params.length) {</span>
<span class="nc" id="L262">              throw new BadFormatString(&quot;index &quot; + num + &quot; from &quot; + format +</span>
                                        &quot; is outside of the valid range 0 to &quot; +
                                        (params.length - 1));
            }
<span class="nc" id="L266">            result.append(params[num]);</span>
<span class="nc" id="L267">          } catch (NumberFormatException nfe) {</span>
<span class="nc" id="L268">            throw new BadFormatString(&quot;bad format in username mapping in &quot; + </span>
                                      paramNum, nfe);
<span class="nc" id="L270">          }</span>
          
        }
<span class="nc" id="L273">        start = match.end();</span>
<span class="nc" id="L274">      }</span>
<span class="nc" id="L275">      return result.toString();</span>
    }

    /**
     * Replace the matches of the from pattern in the base string with the value
     * of the to string.
     * @param base the string to transform
     * @param from the pattern to look for in the base string
     * @param to the string to replace matches of the pattern with
     * @param repeat whether the substitution should be repeated
     * @return
     */
    static String replaceSubstitution(String base, Pattern from, String to, 
                                      boolean repeat) {
<span class="nc" id="L289">      Matcher match = from.matcher(base);</span>
<span class="nc bnc" id="L290" title="All 2 branches missed.">      if (repeat) {</span>
<span class="nc" id="L291">        return match.replaceAll(to);</span>
      } else {
<span class="nc" id="L293">        return match.replaceFirst(to);</span>
      }
    }

    /**
     * Try to apply this rule to the given name represented as a parameter
     * array.
     * @param params first element is the realm, second and later elements are
     *        are the components of the name &quot;a/b@FOO&quot; -&gt; {&quot;FOO&quot;, &quot;a&quot;, &quot;b&quot;}
     * @return the short name if this rule applies or null
     * @throws IOException throws if something is wrong with the rules
     */
    String apply(String[] params) throws IOException {
<span class="nc" id="L306">      String result = null;</span>
<span class="nc bnc" id="L307" title="All 2 branches missed.">      if (isDefault) {</span>
<span class="nc bnc" id="L308" title="All 2 branches missed.">        if (defaultRealm.equals(params[0])) {</span>
<span class="nc" id="L309">          result = params[1];</span>
        }
<span class="nc bnc" id="L311" title="All 2 branches missed.">      } else if (params.length - 1 == numOfComponents) {</span>
<span class="nc" id="L312">        String base = replaceParameters(format, params);</span>
<span class="nc bnc" id="L313" title="All 4 branches missed.">        if (match == null || match.matcher(base).matches()) {</span>
<span class="nc bnc" id="L314" title="All 2 branches missed.">          if (fromPattern == null) {</span>
<span class="nc" id="L315">            result = base;</span>
          } else {
<span class="nc" id="L317">            result = replaceSubstitution(base, fromPattern, toPattern,  repeat);</span>
          }
        }
      }
<span class="nc bnc" id="L321" title="All 4 branches missed.">      if (result != null &amp;&amp; nonSimplePattern.matcher(result).find()) {</span>
<span class="nc" id="L322">        throw new NoMatchingRule(&quot;Non-simple name &quot; + result +</span>
                                 &quot; after auth_to_local rule &quot; + this);
      }
<span class="nc" id="L325">      return result;</span>
    }
  }

  static List&lt;Rule&gt; parseRules(String rules) {
<span class="fc" id="L330">    List&lt;Rule&gt; result = new ArrayList&lt;Rule&gt;();</span>
<span class="fc" id="L331">    String remaining = rules.trim();</span>
<span class="fc bfc" id="L332" title="All 2 branches covered.">    while (remaining.length() &gt; 0) {</span>
<span class="fc" id="L333">      Matcher matcher = ruleParser.matcher(remaining);</span>
<span class="pc bpc" id="L334" title="1 of 2 branches missed.">      if (!matcher.lookingAt()) {</span>
<span class="nc" id="L335">        throw new IllegalArgumentException(&quot;Invalid rule: &quot; + remaining);</span>
      }
<span class="pc bpc" id="L337" title="1 of 2 branches missed.">      if (matcher.group(2) != null) {</span>
<span class="fc" id="L338">        result.add(new Rule());</span>
      } else {
<span class="nc" id="L340">        result.add(new Rule(Integer.parseInt(matcher.group(4)),</span>
<span class="nc" id="L341">                            matcher.group(5),</span>
<span class="nc" id="L342">                            matcher.group(7),</span>
<span class="nc" id="L343">                            matcher.group(9),</span>
<span class="nc" id="L344">                            matcher.group(10),</span>
<span class="nc" id="L345">                            &quot;g&quot;.equals(matcher.group(11))));</span>
      }
<span class="fc" id="L347">      remaining = remaining.substring(matcher.end());</span>
<span class="fc" id="L348">    }</span>
<span class="fc" id="L349">    return result;</span>
  }

  /**
   * Set the static configuration to get the rules.
   * @param conf the new configuration
   * @throws IOException
   */
  public static void setConfiguration() throws IOException {
<span class="fc" id="L358">    String ruleString = System.getProperty(&quot;zookeeper.security.auth_to_local&quot;, &quot;DEFAULT&quot;);</span>
<span class="fc" id="L359">    rules = parseRules(ruleString);</span>
<span class="fc" id="L360">  }</span>

  @SuppressWarnings(&quot;serial&quot;)
  public static class BadFormatString extends IOException {
    BadFormatString(String msg) {
<span class="nc" id="L365">      super(msg);</span>
<span class="nc" id="L366">    }</span>
    BadFormatString(String msg, Throwable err) {
<span class="nc" id="L368">      super(msg, err);</span>
<span class="nc" id="L369">    }</span>
  }

  @SuppressWarnings(&quot;serial&quot;)
  public static class NoMatchingRule extends IOException {
    NoMatchingRule(String msg) {
<span class="nc" id="L375">      super(msg);</span>
<span class="nc" id="L376">    }</span>
  }

  /**
   * Get the translation of the principal name into an operating system
   * user name.
   * @return the short name
   * @throws IOException
   */
  public String getShortName() throws IOException {
    String[] params;
<span class="pc bpc" id="L387" title="1 of 2 branches missed.">    if (hostName == null) {</span>
      // if it is already simple, just return it
<span class="pc bpc" id="L389" title="1 of 2 branches missed.">      if (realm == null) {</span>
<span class="fc" id="L390">        return serviceName;</span>
      }
<span class="nc" id="L392">      params = new String[]{realm, serviceName};</span>
    } else {
<span class="nc" id="L394">      params = new String[]{realm, serviceName, hostName};</span>
    }
<span class="nc bnc" id="L396" title="All 2 branches missed.">    for(Rule r: rules) {</span>
<span class="nc" id="L397">      String result = r.apply(params);</span>
<span class="nc bnc" id="L398" title="All 2 branches missed.">      if (result != null) {</span>
<span class="nc" id="L399">        return result;</span>
      }
<span class="nc" id="L401">    }</span>
<span class="nc" id="L402">    throw new NoMatchingRule(&quot;No rules applied to &quot; + toString());</span>
  }

  static void printRules() throws IOException {
<span class="nc" id="L406">    int i = 0;</span>
<span class="nc bnc" id="L407" title="All 2 branches missed.">    for(Rule r: rules) {</span>
<span class="nc" id="L408">      System.out.println(++i + &quot; &quot; + r);</span>
<span class="nc" id="L409">    }</span>
<span class="nc" id="L410">  }</span>

  public static void main(String[] args) throws Exception {
<span class="nc bnc" id="L413" title="All 2 branches missed.">    for(String arg: args) {</span>
<span class="nc" id="L414">      KerberosName name = new KerberosName(arg);</span>
<span class="nc" id="L415">      System.out.println(&quot;Name: &quot; + name + &quot; to &quot; + name.getShortName());</span>
    }
<span class="nc" id="L417">  }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>